@echo off

rem ---  Setup.bat for EprogW32  ---
rem for Windows 9X/ME/NT/2000 Setup of EprogW32 

rem Author: MAH
rem Date  : 6-Aug-2002
rem Copyright (c) 2002 TR Electronic

rem Modifications

rem 30-Jan-2003: 
rem Added alternate setup without environment variables for brain-damaged Windows
rem installations that don't care for pif settings and don't provide enough environment 
rem space for DOS applications.

rem 7-Jun-2003:
rem Prepended doublequotes for checking empty environment variables replaced by 
rem bracketting doublequotes because Windows XP expects them as pairs.
rem Default setup dir "C:\" replaced by "C:", because '\' is already given in the commands.


rem --- Hints ---

rem 1. The included file Setup.pif allocates the possible maximum of 32768 bytes 
rem    for the environment, to get space for additional entries defined in this batch 
rem    file by set commands.
rem    This value must be larger than 64 bytes plus the space for the predefined
rem    entries, shown by the command "set" typed in the command line.

rem 2. The included file Setup.pif closes the dos box window after termination
rem    of this batch file.

rem 3. The MSDOS utilities "Choice.com" and "Deltree.exe" must be in the search path.
rem    They are part of Windows9X/ME, but not of Windows 2000!

set INF=EprogW32.inf
set SETUPROOT=%WINDIR%
if "%SETUPROOT%"=="" set SETUPROOT=%SYSTEMROOT%
if "%SETUPROOT%"=="" set SETUPROOT=%TMP%
if "%SETUPROOT%"=="" set SETUPROOT=%TEMP%
if "%SETUPROOT%"=="" set SETUPROOT=C:

if "%1"=="FINISHINST" goto %1


rem --- Confirm Start of Installation  ---

:C
cls
echo --- Setup.bat ---
echo Setup copies the selfextracting archive "Setup.pak" to "_setup.exe" in a
echo temporary directory, unpacks the files and runs the included installation
echo script %INF% for Win9X/ME/NT/2000.
echo.
echo You will get an entry in the programs part of the start menu and in the
echo software uninstall list of the control panel.
echo.
echo It is normally not necessary to remove a previous installation. But if
echo problems occur after an update, uninstall from the control panel, reboot
echo and install again.
echo.
echo Please select (Q)uit or Win9X/ME/NT/2000 (S)etup.
echo.

choice /c:QS
if errorlevel 2 goto S
if errorlevel 1 goto E2
goto C


rem --- Check Files and install for 32 bit Win9X/ME/NT/2000 ---

if not exist Setup.pak goto M2

:S
if "%INF%"=="" goto S_
if "%SETUPROOT%"=="" goto S_

copy Setup.pak %SETUPROOT%\_setup.exe
if not exist %SETUPROOT%\_setup.exe goto M3

%SETUPROOT%\_setup.exe /y %SETUPROOT%\_setup\
if not exist %SETUPROOT%\_setup\%INF% goto M4

del %SETUPROOT%\_setup.exe
goto I_NT

:S_
if not exist Setup.pak goto M2

copy Setup.pak C:\_setup.exe
if not exist C:\_setup.exe goto M3_

C:\_setup.exe /y C:\_setup\
if not exist C:\_setup\EprogW32.inf goto M4_

del C:\_setup.exe
goto I_NT_


rem --- Inf file installation for Windows NT/2000 and also Win9X/ME ---

:I_NT
Rundll32 Setupapi.dll,InstallHinfSection DefaultInstall 132 %SETUPROOT%\_setup\%INF%
goto E2
:I_NT_
Rundll32 Setupapi.dll,InstallHinfSection DefaultInstall 132 C:\_setup\EprogW32.inf
goto E2


rem --- Inf file installation for Windows95/98/ME only (currently not used) ---
:I_9X
Rundll Setupx.dll,InstallHinfSection DefaultInstall 132 %SETUPROOT%\_setup\%INF%
goto E2
:I_9X_
Rundll Setupx.dll,InstallHinfSection DefaultInstall 132 C:\_setup\EprogW32.inf
goto E2


rem ---  Finish 32 bit Windows installation, cleanup temporary setup directory ---

:FINISHINST
if "%INF%"=="" goto F_
if "%SETUPROOT%"=="" goto F_

deltree /y %SETUPROOT%\_setup
goto F2

:F_
deltree /y C:\_setup
goto F2

:F2
cls
echo The installation was successful! 
echo.
echo Please look for the new entries in the start menu and in the context menu
echo "Send To".
echo For deinstallation use "Start menu - Settings - Control panel - Software".
echo.
goto E


rem --- Error Messages ---

:M2
echo The setup data file Setup.pak is not at the current path!
echo.
echo If you want to install from a network location, you must copy the setup
echo files to your local drive or you must link it as a network drive:
echo.
echo 1. Call the windows explorer and goto the network 
echo    location via "Desktop - Network environment".
echo 3. Copy the location name from the address field
echo    to the clipboard by marking it and pressing Ctrl-C.
echo 4. Select the explorer menu "Extra - Link network drive"
echo    and insert the location name by pressing Ctrl-V.
echo 5. Goto to this batch file on the new drive and run it.
echo    You may unlink the network drive afterwards.
goto E

:M3
echo Copying to the temporary file %SETUPROOT%\_setup.exe failed!
goto E

:M3_
echo Copying to the temporary file C:\_setup.exe failed!
goto E

:M4
echo Unpacking of %SETUPROOT%\_setup\%INF% failed!
goto E

:M4_
echo Unpacking of C:\_setup\EprogW32.inf failed!
goto E

:E
pause
:E2
set SETUPROOT=
set INF=
